/* Ay B. Sevdik
   97131040  Bilg.Mh.-II
   Dosya Org. BIL212
   DEV#7   Hashing (Linear Quotient) */

#include<stdio.h>
#include<conio.h>
#include <stdlib.h>
#include <string.h>
#include <io.h>

struct student
{                       /* student record */
 char name[30];
} ;
typedef struct student student;
struct record
{
 student S;             /* hash table element */
 int key;
 int tombstone;
} ;
typedef struct record rec;

int Start();                        /* function prototypes */
int valid(int);
int H1(int);
int H2(int);
void Insert(rec *,rec*);
void Delete(rec *,rec *);
void ShowTable(rec *);

void main()                  /* main program */
{
 int response,a,i,j;
 rec htable[11]={"",0,0};     /* hash table is initialized */
 rec temp;
 printf("This program creates an 11 element hash table using "
	"linear quotient.\n");
 response=Start();            /* user is asked what to do */
 while(valid(response))
 {                            /* if response is valid */
  switch(response)
  {
   case 1: printf("Enter student name:\n");    /* record information */
	   scanf("%s",temp.S.name);
	   printf("\nEnter key:\n");             /* is entered */
	   scanf("%d",&temp.key);
	   Insert(&temp,htable);     /* record is inserted into the table */
	   break;

   case 2: printf("Enter the key of the record to be deleted.\n");
	   scanf("%d",&temp.key);
	   Delete(&temp,htable);      /* the requested record is deleted */
	   break;
  case 3:  break;         /* user wants to exit */
  };

  clrscr();
  ShowTable(htable);          /* show the final state of the table */
  getch();
  if(response!=3)
    response=Start();      /* continue asking the user for the next step */
  else                           /* until user wants to exit */
   break;
 }
 getch();
}

int Start()          /* this function asks the user to select */
 {
  clrscr();           /* the next operation to be performed */
  int a;
  printf("Select the operation to perform:\n"
	 " 1.Insert new record\n"
	 " 2.Delete a record\n"
	 " 3.Exit\n");
  scanf("%d",&a);           /* read the response */
  return a;                /* return the response */
 }

 int valid(int x)          /* this function checks if the given */
 {                             /* response is valid or not */
  if((x>=1)&&(x<=3))
   x=1;
  else
   x=0;
  return x;
 }
 int H1(int key)          /* Hashing function 1 */
 {
   return(key%11);
 }
 int H2(int key)          /* Hashing function 2 */
 {
  return((key/11)%11);
 }
 void Insert(rec *rptr,rec *htable)  /* this function inserts */
 {                                       /* a record into the table */
  int flag,i,j,count;
  rec temp;
  i=H1((*rptr).key);          /* Index determined by H1 */
  if(htable[i].tombstone!=1)    /* if the position is not full */
  {
   strcpy(htable[i].S.name,(*rptr).S.name);  /* Insert the record */
   htable[i].key=(*rptr).key;
   htable[i].tombstone=1;
  }
  else                 /* If the position is full */
  {
   j=H2((*rptr).key);    /* Determine increment by H2 */
   count=0;
   if((htable[i].tombstone==1)&&(i==H1(htable[i].key)))
   {
    for(;(count<11)&&(htable[i].tombstone==1);i=((i+j)%11))
    {
     if(htable[i].key==(*rptr).key)  /* if keys are the same */
     {
      printf("Duplicate record!\n");   /* return duplicate message */
      exit(1);
     }              /* continue incrementing until proper */
     count+=1;       /* place is found or table is full */
    }
   }
   else if(i!=H1(htable[i].key)) /* if there is a record not in its actual */
     {                             /*place in the position the new record */
      strcpy(temp.S.name,htable[i].S.name);   /* should be put */
      temp.key=htable[i].key;
      htable[i].tombstone=0;        /* delete the improperly placed */
      flag=1;
     }
   if(count<11)
   {
    strcpy(htable[i].S.name,(*rptr).S.name); /* insert the new record in */
    htable[i].key=(*rptr).key;            /* the proper place */
    htable[i].tombstone=1;
    if(flag==1)
      Insert(&temp,htable);      /* insert the deleted record again */
   }
   else                     /* if the table is full */
   {
    printf("Full table!\n");      /* print a full table message */
    exit(1);
   }
  }
 }

 void Delete(rec *rptr,rec *htable)  /* this function deletes a record */
 {                                         /* from the table */
  int i,j,count;
  i=H1((*rptr).key);
  j=H2((*rptr).key);
  count=0;
  for(;(count<11)&&((*rptr).key!=htable[i].key);i=(i+j)%11)
     count++;                    /* find the place of the record */
  if(count<11)                         /* to be deleted */
    htable[i].tombstone=0;       /*  set tombstone to zero */
  else
  {                                     /* if the record is not found */
   printf("No such record found!\n");    /* print a message */
   exit(1);
  }
 }

 void ShowTable(rec *htable)     /* this function prints the hash table */
 {
  printf("    -----------------------------------------\n");
  printf("    |i | key |           record              |\n");
  printf("    -----------------------------------------\n");
  for(int i=0;i<11;i++)
  {
   if(htable[i].tombstone==1)        /* if the position is occupied */
   {
    printf("    |%2d|%5d",i,htable[i].key);
    printf("|%-30s |\n",htable[i].S.name);
   }
   else                           /* if the position is empty */
    printf("    |%2d|     |                               |\n",i);
   printf("    -----------------------------------------\n");
  }
 }
