	      //  GALIP GULSEN
	      //  BM   97131008

#include <iostream.h>
#include <conio.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>

const SIZE = 11;

typedef struct{   // data record
  int tombStone;
  int no;
  char name[20];
} data;

int HashF(int);
int HashF2(int);

data Table[SIZE] ={{1,1107,"Galip Gulsen"},{1,1111,"Serkan Ozturk"},
		   {1,2207,"Emin S.Baydar"},{1,2206,"Hakan Gor"},
		   {1,3325,"Bekir Oguz"},{1,3313,"Ilknur Durgar"},
		   {1,4414,"Suphi Ceviker"},{1,4445,"Ridvan Cicek"},
		   {1,5521,"Yavuz Ozturk"},{1,6652,"Cagri Cullu"},
		   {1,7791,"Tahsin Sezer"}};

data HashTable[SIZE] ={0};  // Hash Table

void main()
{
  void InsertData(int &);  // Insert a new data to Hash Table
  void DeleteData(int &);  // Deletes a record from the Hash Table
  void FindData(void);     // Finds the wanted record
  void PrintHashTable(void);

  int i, choice, count;
  count = 0;

  clrscr();

  for(i=0; i < SIZE; i++)  // Generates the hash table which datas
  {                        // are given initially.
    int key, key2;

      key = HashF(Table[i].no);

    if (HashTable[key].tombStone == 0)
	HashTable[key] = Table[i];
    else
    {
      key2 = HashF2(HashTable[key].no);

      while(HashTable[key].tombStone != 0)
      {
	key = (key + key2)%11;
      }
      HashTable[key] = Table[i];
    }
    count++;
  }
  do
  {
    clrscr();
    cout << "Enter your choice :\n";
    cout << "1 -> Print the Hash Table.\n";
    cout << "2 -> Insert a new record to the Hash Table.\n";
    cout << "3 -> Delete the given record from the Hash Table.\n";
    cout << "4 -> Find the wanted data.\n";
    cout << "5 -> Exit the program.\n";
    cout << "Your choice --> ";
      cin >> choice;  cout << endl;

    if (choice == 1)
      PrintHashTable();
    else if (choice == 2)
      InsertData(count);
    else if (choice == 3)    //  Choices
      DeleteData(count);
    else if (choice == 4)
      FindData();
    else if (choice == 5)
      exit(0);
    else
    {
      clrscr();
      cout << "Excuse me, wrong choice. Try Again!";
      getch();
      exit(1);
    }
  } while(choice >= 1 || choice <= 3);
  getch();
}

void InsertData(int &Count) // Inserts the given record to the Hash Table
{
  data new_Rec;
  int key, key2;

  if(Count == 11)
    cout << "Unfortunately, the Hash Table is full.\n";
  else
  {
    cout << "Enter the info about the new record\n";
    cout << "Number -> ";
      cin >> new_Rec.no;
    cout << "Name ---> ";
      gets(new_Rec.name);

    new_Rec.tombStone = 1;
    key = HashF(new_Rec.no);

    if (HashTable[key].tombStone == 0)
	HashTable[key] = new_Rec;
    else
    {
      key2 = HashF2(HashTable[key].no);

      while(HashTable[key].tombStone != 0)
      {
	key = (key + key2)%11;
      }
      HashTable[key] = new_Rec;
    }
    cout << "The new record is added to the Hash Table\n";
  }
  cout << "Press any key to continue\n";
  getch();
}

void DeleteData(int &Count) // Deletes the given record from Hash Table
{
  int number, key, key2;
  cout << "Enter the record number to delete\n";
      cin >> number;

  key = HashF(number);

  if (HashTable[key].no == number)
    HashTable[key].tombStone = 0;
  else
  {
    key2 = HashF2(HashTable[key].no);

    while(HashTable[key].no != number)
    {
      key = (key + key2)%11;
    }
    HashTable[key].tombStone = 0;
  }
  Count--;
  cout << "The given record is deleted from the Hash Table\n";
  cout << "Press any key to continue\n";
  getch();
}

void FindData(void) // Finds wanted (by number) record from Hash Table
{
  int number, key, key2;
  cout << "Enter the record number to find\n";
      cin >> number;

  key = HashF(number);

  if (HashTable[key].no == number)
  {
    cout << key << "  " << HashTable[key].no << "  "
	 << HashTable[key].name << "  " << endl;
    getch();
  }
  else
  {
    key2 = HashF2(HashTable[key].no);

    while(HashTable[key].no != number)
    {
      key = (key + key2)%11;
    }
    cout << key << "  " << HashTable[key].no << "  "
	 << HashTable[key].name << "  " << endl;
    getch();
  }
}

void PrintHashTable()  // Prints the whole Hash Table
{
  int i;

  clrscr();
  cout << " THE HASH TABLE (Linear Quotient) \n";
  cout << "**********************************\n";

  for(i=0; i < SIZE; i++)
  {
    if(HashTable[i].tombStone == 1)
      cout << i << "  " << HashTable[i].no << "  "
	   << HashTable[i].name << "  " << endl;
    else
      cout << i << "   ---------\n";
  }
  cout << "Press any key to continue\n";
  getch();
}

int HashF(int temp)   // The Hashing function 1
{
  return  temp%11;
}

int HashF2(int temp)  // The Hashing function 2
{
  return (temp/11)%11;
}










