   /*
   Rabia Nuray
   97131044
   File Organization homework
   Creating a hash table (coalesced hashing)
   */

#include <stdio.h>
#include <stdlib.h>
#define MAXLENGTH 11
//R is the pointer for hashTable.Points to an empty location
int R = 10;
//Record for table, includes key value(no) and name
struct Person{
       int no;
       char name[20];
};
// Record for hash table it uses a tombstone.It is 0 for deleted recs.
// 1 for active recs.There is a ptr to structure hash table it is used
//for link
struct HashTable{
       int tombstone;
       struct Person a;
       struct HashTable *iptr;

};

//This function initializes the values of hash table record
//tombstone is 0 and ptr  is NULL
void Initialize(struct HashTable * coalesced)
{
  coalesced ->tombstone = 0;
  coalesced ->iptr = NULL;
}
//This insertion function uses the hash function key mod p,
// p is the prime number bigger than n=10,
// this function construct a coalesced hash table
void Insertion(struct HashTable * c,struct Person *b)
{
   int hval = b -> no % 11;       //hash funtion is used

   if ( c[hval].tombstone == 0 ) {
   //if the home address is empty, insert this record to its home address
	c[hval].tombstone = 1;
	c[hval].a = *b ;
   }
   else	{
   //if there is a record at the home address, follow link and insert
   //record to Rth location .Link the tail of chain
	while ( c[hval].iptr != NULL) {
		// if the record is in table print message and break
		if (c[hval].a.no == b -> no ) {
			printf("Duplicate records\n");
			break;
		}
		if(  c[hval].tombstone == 0)
		    break;
		hval = c[hval].iptr - c ;//computes the location of link,
					//uses pointer arithmetic
	}
	//insertion of record and linking it to the chain
	if (!(c[hval].a.no == b -> no) ) {
	    if(c[R].tombstone == 0 ) {
	       c[R].a = * b ;
	       c[R].tombstone = 1 ;
	       c[hval].iptr = & c[R];
	    }
	    else {
		while ( R >= 0 && c[R].tombstone == 1 )
		    R--;
		c[R].a = * b ;
		c[R].tombstone = 1 ;
		c[hval].iptr = & c[R];
	    }
	    //R will point to the first empty location
	    while ( R >= 0 && c[R].tombstone == 1 )
		R--;
	    // if table is full, print message
	    if( R < 0)
		printf("Table is full\n");
	}
   }
}

//This function searchs for a record in hash table
int Search(struct HashTable * c,struct Person *b)
{
 int hval = b->no % 11; //uses hash function
 //check for the record is either at home address or not
 if ( c[hval].a.no == b -> no ){
	printf("It is on %d. location\n",hval);
	return hval;
 }
 //check for it is in the table or not
 else {
	while ( c[hval].tombstone == 1 ) {
		hval=c[hval].iptr - c;
		if ( c[hval].a.no == b -> no )
			break;
	}
	if ( c[hval].tombstone == 1 ) {
	      printf("It is on %d. location\n",hval);
	      return hval;
	}
	else {
	      printf("It is not in the table\n");
	      return -1;
	}
 }
}

//Delete the given record from the hash table
void Deletion(struct HashTable * c,struct Person *b )
{
  int hval = Search ( c , b ) ;//check for if it is in the table
  int loc =hval,pos=-1;
  //if it is in the table then
  if ( hval != -1 ) {
  //if it is at the home address delete it.Assign tombstone to 0
   if ( c[hval].iptr == NULL ) {
	c[hval].tombstone = 0;
   }
   //if it is in the chain then
   else {
	//Look for the last record for the home address loc
	while ( c[hval].iptr != NULL && c[hval].tombstone != 0  ) {
	       hval = c[hval].iptr -c;
	       if ( loc == c[hval].a.no % 11 )
		   pos = hval;
	}
	//if there is a record whose home address is loc
	//move it to the loc
	if ( pos != -1 && c[pos].iptr == NULL ) {
	     c[loc].a = c[pos].a;
	     c[pos].tombstone = 0;
	}
	else if ( pos != -1 && c[pos].iptr != NULL ) {
	     hval=loc;
	     while ( c[hval].iptr != &c[pos])
	       hval=c[hval].iptr-c;
	     c[hval].iptr=c[pos].iptr;
	     c[loc].a=c[pos].a;
	     c[pos].tombstone=0;
	}
	//if there is no record at this home address ,
	//move the next record to that location
	else if( pos == -1 && c[pos].iptr != NULL ) {
	    c[loc].iptr->tombstone = 0;
	    c[loc].a=c[loc].iptr->a;
	    c[loc].iptr=c[loc].iptr->iptr;
	}
       else
	   c[loc].tombstone = 0;
   }
   while ( R <= 10 &&c[R].tombstone == 1 )
	   R ++;
  }
}

//uses the hash table
void main()
{
    struct Person a;
    struct HashTable c[MAXLENGTH];
    int i;
    clrscr();
    for ( i = 0 ; i < 11 ; i++)
       Initialize( & c[i] );//initializes the all element of c array
    printf("Enter no and name Ctrl+Z for Exit\n" );
    scanf("%d%s",&a.no,a.name);
    while ( !feof(stdin) ){
	Insertion(c,&a);
	printf("Enter no and name\n" );
	scanf("%d%s",&a.no,a.name);
    }
    printf ("The hash table is\n");
    for( i=0 ; i<MAXLENGTH ;i++ ) {
     if ( c[i].tombstone == 1)
	printf("%2d |%4d|%20s|%d\n",i,c[i].a.no,c[i].a.name,c[i].iptr-c);
     else
	printf("%2d |\n",i);
    }
    printf("Which person do you want to delete?\nEnter his/her number\n");
    scanf("%d",&a);
    Deletion(c,&a);
    printf("The updated hash table is:\n");
    for(i = 0 ;i < MAXLENGTH ; i++){
     if( c[i].tombstone == 1)
	 printf("%2d |%4d|%20s| %d\n",i,c[i].a.no,c[i].a.name,c[i].iptr-c);
     else
	 printf("%2d |\n" ,i);
    }
}